=== debian/changelog ===
shiboken2 (2.0.0.dev0-0~201712141347~rev1722~pkg76~ubuntu17.04.1) zesty; urgency=low

  * Auto build.

 -- Thomas Karl Pietrowski <thopiekar@googlemail.com>  Thu, 14 Dec 2017 13:47:07 +0000
