## shiboken2 2.0.0.dev0-0~201712141347~rev1722~pkg76~ubuntu17.10.1

=== debian/changelog ===
shiboken2 (2.0.0.dev0-0~201712141347~rev1722~pkg76~ubuntu17.10.1) artful; urgency=low

  * Auto build.

 -- Thomas Karl Pietrowski <thopiekar@googlemail.com>  Thu, 14 Dec 2017 13:47:02 +0000
