=== debian/control ===
Source: shiboken2
Section: devel
Priority: optional
Maintainer: Thomas Karl Pietrowski <thopiekar@googlemail.com>
Build-Depends:
 dpkg-dev (>= 1.15.7), debhelper (>= 9),
 cmake (>= 3.0), dh-python,
# LLVM/CLang
 llvm, clang, libclang-dev,
# Qt5
 qtbase5-dev (>= 5.7), libqt5xmlpatterns5-dev,
# Others
 libsparsehash-dev (>= 1.6-1.1~),
 libxml2-dev (>= 2.6.32), libxslt1-dev (>= 1.1.19),
# Python2*
 python-all-dev (>= 2.7), python-all-dbg (>= 2.7),
 python-numpy, python-numpy-dbg,
# Python3*
 python3-all-dev (>= 3.2), python3-all-dbg (>= 3.2),
 python3-numpy, python3-numpy-dbg,
# Documentation
 python-sphinx, python3-sphinx
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.3
Standards-Version: 3.9.5
Homepage: https://github.com/thopiekar/PySide-packaging
Vcs-Git: git://code.qt.io/pyside/shiboken.git
Vcs-Browser: http://code.qt.io/cgit/pyside/shiboken.git/

Package: shiboken2
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: CPython bindings generator for C++ libraries
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It collects information from library headers, and then
 merges modifications and handwritten code defined in the typesystem
 description.
 .
 Shiboken is the binding generator used to create the PySide bindings.

Package: shiboken2-doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Section: doc
Description: CPython bindings generator for C++ libraries documentation
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It collects information from library headers, and then
 merges modifications and handwritten code defined in the typesystem
 description.
 .
 Shiboken is the binding generator used to create the PySide bindings; this
 package contains its documentation.

Package: libshiboken2.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CPython bindings generator for C++ libraries - shared library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It collects information from library headers, and then
 merges modifications and handwritten code defined in the typesystem
 description.
 .
 This is the shared library used by shiboken.

Package: libshiboken-py3-2.0
Section: libs
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: same
Description: CPython3 bindings generator for C++ libraries - shared library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It collects information from library headers, and then
 merges modifications and handwritten code defined in the typesystem
 description.
 .
 This is the shared library used by shiboken when used with python3.

Package: libshiboken2-dev
Section: libdevel
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 python-dev, python3-dev,
 libshiboken2.0 (= ${binary:Version}),
 libshiboken-py3-2.0 (= ${binary:Version})
Description: development files for the shiboken bindings generator library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It collects information from library headers, and then
 merges modifications and handwritten code defined in the typesystem
 description.
 .
 This package contains the development files for the library.

Package: shiboken2-dbg
Section: debug
Architecture: any
Priority: extra
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libshiboken2.0 (= ${binary:Version}),
 shiboken2 (= ${binary:Version})
Description: debugging symbols for shiboken and its library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It collects information from library headers, and then
 merges modifications and handwritten code defined in the typesystem
 description.
 .
 This package contains the debugging symbols for shiboken and libshiboken.
